""
PROJECTNAME SingleInstance .
PROJECTCATEGORY  .


PROFILE
BEGIN
  BUILD.INCLUDESYMBOLTABLE = 0
  BUILD.BASEADDRESS = 4194304
  BUILD.RES = 0
  BUILD.IMAGEFLAGS = 8
  BUILD.THREADINGMODEL.SYNCREQUIRED = 0
  BUILD.BINDIMAGE = 0
  BUILD.APPNAME = 'SingleInstance'
  BUILD.THREADINGMODEL = -1
  BUILD.OPTIMIZESTRUCTS = 0
  BUILD.CLEARGLOBALS = 1
  BUILD.DEBUGMODE = 0
  BUILD.EXCLUDESUPERMETHODS = 1
  BUILD.REGISTEROCX = 0
  BUILD.RWTEXT = 0
  BUILD.SPLITDEBUGSYMBOLS = 0
END

CLASS SingleInstanceWindow
INCLUDEDEF=1
CLASSMETHODS *
INSTANCEMETHODS *
! !
FrameWindow subclass: #SingleInstanceWindow
	instanceVariableNames: 'm_mutex '
	classVariableNames: ''
	poolDictionaries: ''
	comment: '

This is a test in an executable of the WINAPI BringWindowToTop.

'
	category: ''!

!SingleInstanceWindow class .EXTERN methods 12:55 - 02/26/01!
initialize
	"
	Private - Initializes the event handlers.
	"
	super initialize.! !

!SingleInstanceWindow class Attributes methods 08:33 - 03/07/01!
windowClassName
	"
	Private - Answers class name for windows of this class.
	Return Value: 
		A String.
	"
	^'SingleInstanceFrame'! !

!SingleInstanceWindow Init / Release methods 08:50 - 03/07/01!
closeWindow
	"
	This method is called when a WM_CLOSE is received. The implementor 
	returns NULL to close the window, any other value prevents it from being
	closed. The default implementation raises the #close event.
	Return Value: 
		NULL or 1. 
	"
	m_mutex notNil ifTrue: [
		m_mutex close.
		m_mutex := nil.
	].
	^NULL! !

!SingleInstanceWindow Attributes methods 12:55 - 02/26/01!
initPosition
	"
	Answers the initial window position.
	Return Value: 
		A WinPoint.
	"
	^250@160! !

!SingleInstanceWindow Init / Release methods 08:50 - 03/07/01!
initWindow
	"
	Private - DO NOT MODIFY - generated by Interface Builder. Creates child controls for
	this window.
	Return Value: 
		The receiver.
	"
	(Static openWindow: IDC_STATIC
		title: 'Put me on top!!'
		exStyle: 0
		style: WS_CHILD|WS_VISIBLE
		parent: self
		framing: (FrameMatrix scale: #(0 0 0 0) offset: #(32 26 129 44))).! !

!SingleInstanceWindow Init / Release methods 08:50 - 03/07/01!
open
	"
	1. Check for a previous instance of the application. 
	If a previous instance is running:
		a. If the previous instance is minimized, restore it; or
		b. If the previous instance is not minimized, bring it to the top; 
		and
		c. Abort the open operation. 

	2. If no previous instance is running, open the receiver.
	"
	| alreadyExists wndPrevInstance|
	" create and enter mutex "
	m_mutex := WinMutex createMutex: 'STSingleInstanceMutex' initialState: true.
	" determine if we created the mutex "
	alreadyExists := m_mutex alreadyExists.
	" release the mutex "
	m_mutex release. 
	
	alreadyExists ifTrue: [
		"A previous instance is running"
		"Get the prev instance handle"
		(wndPrevInstance := self class findWindow) notNil ifTrue: [
			wndPrevInstance isIconic ifTrue: [
				MessageBox title: 'BringWindowToTop Test' text: 'Previous instance is minimized'.
				wndPrevInstance showWindow: SW_RESTORE
			]
			ifFalse: [
				MessageBox title: 'BringWindowToTop Test' text: 'Previous instance is not minimized'.
				WINAPI BringWindowToTop: wndPrevInstance
			].
		].
		" close our handle to the mutex "
		m_mutex close.
		"...and abort the open operation"
		^nil
	].
	super open. 
	m_mutex release.
	^self! !

!SingleInstanceWindow Attributes methods 08:32 - 03/07/01!
windowTitle
	"
	Returns the default title string for this window.
	Return Value:
		A String with the title to display, an Integer resource identifier, or NULL if no title should be displayed.
	"
	^'Single Instance'! !

Compiler addCatDescription: '.EXTERN' text: '.EXTERN
Includes the source, but discards the code when the image is compressed.'.
Compiler addCatDescription: 'Init / Release' text: 'Init / Release
Initialization and Release methods.'.
Compiler addCatDescription: 'Attributes' text: 'Attributes of the receiver'.!
