""
PROJECTNAME updates .
PROJECTCATEGORY  .

CLASS SyncObject
INCLUDEDEF=0
CLASSMETHODS 
BEGIN
END
INSTANCEMETHODS 
BEGIN
	alreadyExists
END

CLASS Window
INCLUDEDEF=0
CLASSMETHODS 
BEGIN
	findWindow
END
INSTANCEMETHODS 
BEGIN
	setForegroundWindow
END
! !

!SyncObject Testing methods 08:32 - 03/07/01!
alreadyExists
	" 
	Determines if a named sync object already existed before a creation
	call.
	This method must be called right after a creation call.
	"
	^WINAPI GetLastError == ERROR_ALREADY_EXISTS! !

!Window class Operations methods 08:50 - 03/07/01!
findWindow
	"
	The findWindow method retrieves a handle to a top-level window whose class name 
	matches the receiver's windowClassName.  
	This method does not search child windows. This method does not perform a case-sensitive search.
	Return Value: 
		A Window instance if successful, otherwise the return value is nil. 
	"
	|hwnd|
	hwnd := WINAPI FindWindow: self windowClassName basicAddress with: NULL.
	hwnd ~~ NULL ifTrue: [
		^Window fromHandle: hwnd
	].
	^nil! !

!Window Operations methods 09:13 - 03/07/01!
setForegroundWindow
	"
	The SetForegroundWindow function puts the thread that created the specified window 
	into the foreground and activates the window. Keyboard input is directed to the window, 
	and various visual cues are changed for the user. The system assigns a slightly higher 
	priority to the thread that created the foreground window than it does to other threads. 
	Return Value: 
		If the window was brought to the foreground, the return value is true.
		If the window was not brought to the foreground, the return value is false. 
	"
	^(WINAPI SetForegroundWindow: m_handle) ~~ FALSE! !

Compiler addCatDescription: 'Operations' text: 'Operations
Operations on this object'.
Compiler addCatDescription: 'Testing' text: 'Testing
Test the receiver and answer a Boolean.'.!
